//+------------------------------------------------------------------+
//|                                                 MP DailyStat.mq4 |
//|                                                          Rafaell |
//|                                                          http:// |
//+------------------------------------------------------------------+


#property copyright "Rafaell"
#property link      "http://"

#property indicator_chart_window



#import "MPDailyStat.dll"
int SymCount(string  ,int);
string SymSett(string,string& arr[] , int, int);
#import


extern string  ISymbols = "EURUSD,GBPUSD,USDCHF,USDCAD,AUDUSD,NZDUSD,GBPCHF,GBPJPY,EURCHF";
extern bool    changeInPips = True;   
extern int     statMode=1;
extern bool showDailyStat=True;
extern bool showMTStat = True;
extern int     timeAdj=0;

int dataPeriod = PERIOD_H1;
int tf[]={PERIOD_MN1, PERIOD_W1, PERIOD_D1, PERIOD_H4, PERIOD_H1, PERIOD_M30, PERIOD_M15, PERIOD_M5};
string tfs[] = {"MN", "W", "D", "H4", "H1", "M30", "M15", "M5"};

int i,j,n,m;
int numSym;
int checkForData=0;
double   current[],
         pcurrent[],
         dh[],
         dl[],
         dch[],
         dcl[],
         dco[],
         dr[],
         dmco[][8];
double toPoint[];
string ssym[];
string ind;
int   xx=5,
      xx0;
int yy=5;
int numPrObj;
datetime pTime[];
int fontSize=10;
bool recaldata[];
color textCol=YellowGreen;
color dCol = Red;
color uCol = LightGreen;   
color nCol = Gold;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators


   
   numSym = SymCount(ISymbols,StringLen(ISymbols));
   if (numSym > 10)
      numSym = 10;
   ArrayResize(ssym, numSym);
   
   n=0;
   for (i=0; i<numSym; i++) {
      ssym[i-n] = SymSett(ISymbols, ssym, numSym,i);
      if (iOpen(ssym[i-n],dataPeriod,1) == 0) {          
         checkForData = CheckForData(i-n);
//         if (checkForData < 0)
//            n++;
      }  
   }
//   numSym -= n;
 
   
   ArrayResize(current, numSym);
   ArrayResize(dh, numSym);
   ArrayResize(dl, numSym);
   ArrayResize(dch, numSym);
   ArrayResize(dcl, numSym);
   ArrayResize(dco, numSym);
   ArrayResize(dr, numSym);
   ArrayResize(toPoint, numSym);      
   ArrayResize(dmco, numSym);
   ArrayResize(pcurrent, numSym);
   ArrayResize(pTime, numSym);
   ArrayResize(recaldata, numSym);
   
   
   ind = WindowExpertName();
   IndicatorShortName(ind); 
   
   for (i=0; i<numSym; i++) {
      if (MarketInfo(ssym[0], MODE_DIGITS) == 3 || MarketInfo(ssym[0], MODE_DIGITS) == 5)
         toPoint[i]=MarketInfo(ssym[i], MODE_POINT) * 10;
      else
         toPoint[i]=MarketInfo(ssym[i], MODE_POINT);
   }  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for (i=0; i<=(numSym+1)*(n+m); i++)
      ObjectDelete(ind+(i)); 
        
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   int lDataBar=4;
   
   int typHist = 1;
   int OpenTime = 0;
   
   
   for(i=0; i<numSym; i++)
      recaldata[i] = False; 

   
   lDataBar = iBarShift(ssym[0], dataPeriod, StartBar(0, 0, 0, 1, statMode, timeAdj), False);
   
   if (showDailyStat == True || showMTStat == True) {
      for (i=0; i<numSym; i++) {
         current[i] = MarketInfo(ssym[i], MODE_BID);
         if (current[i] == 0) {
            dh[i]=0;
            dl[i]=0;
            dch[i]=0;
            dcl[i]=0;
            dco[i]=0;
         }
         else if ((current[i] != pcurrent[i]) || iTime(ssym[i], dataPeriod,0)  != pTime[i]) { 
            recaldata[i] = True;
            dh[i] = iHigh(ssym[i], dataPeriod, iHighest(ssym[i],dataPeriod,MODE_HIGH, lDataBar,0));
            dl[i] = iLow(ssym[i], dataPeriod, iLowest(ssym[i],dataPeriod,MODE_LOW, lDataBar,0));
            dch[i] = (dh[i]-current[i])/toPoint[i];
            dcl[i] = (current[i]-dl[i])/toPoint[i];
            dr[i] = (dh[i]-dl[i])/toPoint[i];
            if (changeInPips == True)
               dco[i] = (current[i]- iOpen(ssym[i],dataPeriod,lDataBar))/toPoint[i];
            else
               dco[i] = (current[i]- iOpen(ssym[i],dataPeriod,lDataBar))*100/iOpen(ssym[i],dataPeriod,lDataBar);
         }
      }
   }      
      



   
   if (showDailyStat == True) {
      n=6;
      xx0=190;

         WriteL(ind+0, 1, xx+165, yy, StringConcatenate("From: ",TimeToStr(iTime(NULL, dataPeriod, lDataBar),TIME_DATE|TIME_MINUTES)), fontSize-3,NULL ,textCol);   
         WriteL(ind+1, 1, xx+140, yy," Bid     ", fontSize-3,NULL ,textCol);
         WriteL(ind+2, 1, xx+105, yy," Daily range ", fontSize-3,NULL ,textCol); 
         WriteL(ind+3, 1, xx+70, yy," From high ", fontSize-3,NULL ,textCol);
         WriteL(ind+4, 1, xx+40, yy," From low ", fontSize-3,NULL ,textCol);
         WriteL(ind+5, 1, xx, yy," Change ", fontSize-3,NULL ,textCol);
      
      for (i=0; i<numSym; i++) {
         if (recaldata[i] == True) {
            color cCol = SetCol(dco[i]);
            WriteL(ind+(i+n), 1, xx+190, yy+10*(i+1), ssym[i], fontSize,NULL ,cCol); 
            WriteL(ind+(i+n+1*numSym), 1, xx+140, yy+10*(i+1), DoubleToStr(current[i], MarketInfo(ssym[i], MODE_DIGITS)), fontSize,NULL ,cCol); 
            WriteL(ind+(i+n+2*numSym), 1, xx+105, yy+10*(i+1), DoubleToStr(dr[i], 0), fontSize,NULL ,cCol);
            WriteL(ind+(i+n+3*numSym), 1, xx+70, yy+10*(i+1), DoubleToStr(dch[i], 0), fontSize,NULL ,cCol); 
            WriteL(ind+(i+n+4*numSym), 1, xx+40, yy+10*(i+1), DoubleToStr(dcl[i], 0), fontSize,NULL ,cCol); 
            if (changeInPips == True)
               WriteL(ind+(i+n+5*numSym), 1, xx, yy+10*(i+1), DoubleToStr(dco[i], 0), fontSize,NULL ,cCol); 
            else
               WriteL(ind+(i+n+5*numSym), 1, xx, yy+10*(i+1), StringConcatenate(DoubleToStr(dco[i], 2),"%"), fontSize,NULL ,cCol);
         }
      }
   } 
   else {
      n=1;
      xx0=xx;
      WriteL(ind+0, 1, xx, yy, "Symbol", fontSize-3,NULL ,textCol);
      for (i=0; i<numSym; i++) {
         WriteL(ind+(i+n), 1, xx, yy+10*(i+1), ssym[i], fontSize,NULL , SetCol(0));
      }
   }
   
   if (showMTStat == True) {
      m=8;
      numPrObj = n*(numSym+1);
      xx0 += 55;

         for (i=0; i<8; i++) 
            WriteL(ind+(i+numPrObj), 1, xx0+i*35, yy, tfs[i], fontSize-3,NULL ,textCol);
     
      
      numPrObj += numSym;
      for (i=0; i<numSym; i++) {
         if (recaldata[i] == True) {
            for (j=0; j<8; j++) {
               dmco[i][j]= (current[i]- iOpen(ssym[i],tf[j],0))/toPoint[i];
               WriteL(ind+(i+j*numSym+numPrObj), 1, xx0+j*35, yy+10*(i+1), DoubleToStr(dmco[i][j], 0), fontSize,NULL ,SetCol(dmco[i][j]));
            }
         }
         
      }
   }
   for (i=0; i<numSym; i++) {
      pcurrent[i] = current[i];
      pTime[i] = iTime(ssym[i], tf[8],0);   
   }
//----
   return(0);
  }

//+------------------------------------------------------------------+




void WriteL(string LBL, double Side, int X, int Y, string text, int fontsize, string fontname, color Tcolor)
{


  ObjectCreate(LBL, OBJ_LABEL, 0, 0 , 0);
  ObjectSetText(LBL,text, fontsize, fontname, Tcolor);
  ObjectSet(LBL, OBJPROP_CORNER, Side);
 
  ObjectSet(LBL, OBJPROP_XDISTANCE, X);
  ObjectSet(LBL, OBJPROP_YDISTANCE, Y);
 
 
}

//+------------------------------------------------------------------+





datetime StartBar(int dye, int dmo, int dwe, int dda, int typ, int ot)
{
   int ye,mo,da,ho;
   datetime ct;
     
      
   ct=TimeCurrent();
   switch (typ) {
      case 0: {
         ct -= 60*60*(24)*(dda-1);
         ct -= 60*60*24*(7)*(dwe);
         
         ye = TimeYear(ct);
         mo = TimeMonth(ct);
         da = TimeDay(ct);
         ho = TimeHour(ct);

         if (dda > 0)
            ho=0;
         if (dwe > 0) {
            da -= (TimeDayOfWeek(TimeCurrent())-1);
            ho=0;
            //da -= DayOfWeek();      
         }
         if (dmo > 0) {
           da=1;
           ho=0;
           mo -= (dmo-1);
           while (mo < 0) {
               mo +=12;
               ye -= 1;
            }
         }
         if (dye > 0) {
           da=1;
           mo=1;
           // da  -= DayOfYear()+1 ;
           ho=0;
           ye -= (dye-1);
         
         }
       if (ot != 0) {
           ct = StrToTime(da+"."+mo+"."+ye+" "+ho);
           if (ot > TimeHour(TimeCurrent()))
               ct = ct + (ot-24)*3600;     
           else 
             ct += (ot)*3600;    
           //cd -=  (ot)*3600
           ye = TimeYear(ct);
           mo = TimeMonth(ct);
           da = TimeDay(ct);
           ho = TimeHour(ct);
        }
        
      } break;
      
      case 1: {      
         ct = TimeCurrent()+3600;
         if (dda > 0) 
            ct -= 60*60*(24)*dda;
         if (dwe > 0)
            ct -= 60*60*24*(7)*dwe;   
      
         ye = TimeYear(ct);
         mo = TimeMonth(ct);
         da = TimeDay(ct);
         ho = TimeHour(ct);
      
         if (dmo > 0) {
            mo -= dmo;
            while (mo < 0) {
               mo +=12;
               ye -= 1;
            }
         }
         if (dye > 0) {
            ye -= dye;
         }
     } break;
     
     default: {
         ye = Year();
          mo = Month();
          da = Day();
         ho = Hour();   
     } break;
  }   
 // return (StrToTime(StringConcatenate(/*"D'",*/da,".",mo,".",ye," ",ho/*,"'"*/)));
  return (StrToTime(da+"."+mo+"."+ye+" "+ho));   
} 

//+------------------------------------------------------------------+

color SetCol(double param)
{
   if (param > 0)
      return(uCol);
   else if (param < 0)
      return(dCol);
   else
      return(nCol);
}
      

//+------------------------------------------------------------------+

int CheckForData(int n)
{
   
   if (iOpen(ssym[n],dataPeriod,0) == 0) {
      for (int j=0; j<10; j++) {
         Sleep(500);
         if (iOpen(ssym[n],dataPeriod,0) > 0) 
            return (0);
      }               
      if (iOpen(ssym[n],dataPeriod,0) > 0) 
          return (0);
      else 
         Alert("Please check currency symbol inputs. No spaces, ...just symbols and ',' \n If your inputs are OK, maybe need some time to update data!!  ", ssym[i]);
   }
   return (-1);
}

//+------------------------------------------------------------------+ 
    